---
product: "AG Grid"
title: "Set Filter - Mini Filter"
description: "This section describes the behaviour of the Mini Filter and shows how it can be configured."
enterprise: true
framework: javascript
version: "36.2.0"
related:
    - title: "Filter List"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-filter-list/"
    - title: "Data Updates"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-data-updates/"
    - title: "Tree List"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-tree-list/"
    - title: "Excel Mode"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-excel-mode/"
    - title: "API"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-api/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Set Filter - Mini Filter

This section describes the behaviour of the Mini Filter and shows how it can be configured.

The Mini Filter allows the user to search for particular values in the Filter List. Entering text into the Mini Filter will narrow down the presented list of values shown inside the Set Filter, but by default will not filter the data inside the grid.

[Video](https://www.ag-grid.com/archive/36.2.0/_astro/mini-filter.-EPD4Dmp.mp4)

## Keyboard Shortcuts

When the `↵ Enter` key is pressed while on the Mini Filter, the Set Filter will exclusively select all values in the Filter List that pass the Mini Filter and apply the filter immediately (note that even if an Apply Button is used, hitting `↵ Enter` applies the filter).

Alternatively, you can choose to have the Mini Filter applied as the user is typing, i.e. as the Filter List is filtered, the Set Filter will be applied as described above so that the results in the grid will also be filtered at the same time. To enable this behaviour, use the following:

```js
const gridOptions = {
    columnDefs: [
        {
            field: 'country',
            filter: 'agSetColumnFilter',
            filterParams: {
                applyMiniFilterWhileTyping: true,
            },
        }
    ],

    // other grid options ...
}
```

The following example demonstrates this behaviour. Note the following:

- The Athlete column's Set Filter shows the Mini Filter with default behaviour. Try typing in the Mini Filter to search the Filter List, and then hit the `↵ Enter` key and notice how the grid is filtered using the displayed values.
- The Country column's Set Filter applies the Mini Filter as you type because `filterParams.applyMiniFilterWhileTyping = true`.

#### Mini Filter Keyboard Shortcuts

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ISetFilterParams,
  ModuleRegistry,
  NumberFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    // set filters
    { field: "athlete", filter: "agSetColumnFilter" },
    {
      field: "country",
      filter: "agSetColumnFilter",
      filterParams: {
        applyMiniFilterWhileTyping: true,
      } as ISetFilterParams,
    },

    // number filters
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze", filter: "agNumberColumnFilter" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 200,
    floatingFilter: true,
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Mini Filter Keyboard Shortcuts](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/mini-filter-keyboard-shortcuts/typescript/)

## Custom Searches

Sometimes it is necessary to provide custom handling for Mini Filter searches, for example to substitute accented characters.

As with the [Text Filter](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-text/#text-formatter) it is possible to supply a Text Formatter to the Set Filter which formats the text before applying the Mini Filter compare logic. The snippet below shows how this can be configured:

```js
const gridOptions = {
    columnDefs: [
        {
            field: 'athlete',
            filter: 'agSetColumnFilter',
            filterParams: {
                textFormatter: value => {
                    return value
                        .replace(/\s/g, '')
                        .replace(/[àáâãäå]/g, 'a')
                        .replace(/æ/g, 'ae')
                        .replace(/ç/g, 'c')
                        .replace(/[èéêë]/g, 'e')
                        .replace(/[ìíîï]/g, 'i')
                        .replace(/ñ/g, 'n')
                        .replace(/[òóôõö]/g, 'o')
                        .replace(/œ/g, 'oe')
                        .replace(/[ùúûü]/g, 'u')
                        .replace(/[ýÿ]/g, 'y')
                        .replace(/\W/g, '');
                }
            }
        }
    ],

    // other grid options ...
}
```

The following example demonstrates searching when there are accented characters. Note the following:

- The Athlete column's Set filter is supplied a text formatter via `filterParams.textFormatter` to ignore accents.
- Searching using `'bjorn'` will return all values containing `'björn'`.

The formatter is also passed the grid `api` and `context` as a second argument, along with the `column` and `colDef` it is working on. One callback set on `defaultColDef.filterParams` can therefore serve every column it applies to.

#### Mini Filter Text Formatter

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ISetFilterParams,
  ModuleRegistry,
  NumberFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);

function replaceAccents(value: string) {
  return value
    .replace(new RegExp("[àáâãäå]", "g"), "a")
    .replace(new RegExp("æ", "g"), "ae")
    .replace(new RegExp("ç", "g"), "c")
    .replace(new RegExp("[èéêë]", "g"), "e")
    .replace(new RegExp("[ìíîï]", "g"), "i")
    .replace(new RegExp("ñ", "g"), "n")
    .replace(new RegExp("[òóôõøö]", "g"), "o")
    .replace(new RegExp("œ", "g"), "oe")
    .replace(new RegExp("[ùúûü]", "g"), "u")
    .replace(new RegExp("[ýÿ]", "g"), "y")
    .replace(new RegExp("\\W", "g"), "");
}

const filterParams: ISetFilterParams = {
  textFormatter: replaceAccents,
};

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    // set filter
    {
      field: "athlete",
      filter: "agSetColumnFilter",
      filterParams: filterParams,
    },
    // number filters
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze", filter: "agNumberColumnFilter" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 200,
    floatingFilter: true,
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Mini Filter Text Formatter](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/mini-filter-text-formatter/typescript/)

## Enabling Case-Sensitive Searches

By default the Mini Filter is case-insensitive. Practically this means that searching for `bl` would match Filter List values of `Black`, `blue` and `BLONDE`.

Case-sensitive searches can be enabled by using the `caseSensitive` filter parameter:

```js
const gridOptions = {
    columnDefs: [
        {
            field: 'colour',
            filter: 'agSetColumnFilter',
            filterParams: {
                caseSensitive: true
            }
        }
    ],

    // other grid options ...
}
```

> **Note**
>
> The `caseSensitive` option also affects the values presented in the [Filter List](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-filter-list/#enabling-value-case-sensitivity) and [API](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-api/#enabling-case-sensitivity) behaviours.

See [Example: Filter List Case-Sensitivity](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/filter-set-filter-list/#enabling-value-case-sensitivity) for a demonstration of the change in behaviour.

## Text Customisation

Text used in the Mini Filter can be customised using [Localisation](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/localisation/).

The text shown as a placeholder in the Mini Filter textbox can be customised by setting `'searchOoo'`.

When no matching values are found when typing in the Mini Filter, a message is displayed. This can be customised by setting `'noMatches'`.

The example below shows this text being customised:

- `searchOoo` is set so that the Mini Filter textbox displays `'Search values...'` instead of the default text `'Search...'`
- `noMatches` is set so that when no matches are found for the Mini Filter search, the message displays `'No matches could be found.'` instead of `'No matches.'`

#### Text Customisation

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  LocaleModule,
  ModuleRegistry,
  NumberFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  LocaleModule,
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    // set filters
    { field: "athlete", filter: "agSetColumnFilter" },
    { field: "country", filter: "agSetColumnFilter" },

    // number filters
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze", filter: "agNumberColumnFilter" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 200,
    floatingFilter: true,
  },
  localeText: {
    searchOoo: "Search values...",
    noMatches: "No matches could be found.",
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Text Customisation](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/text-customisation/typescript/)

The Mini Filter input shares the grid-wide input behaviour (clear button, browser autocomplete) described in [Input Fields](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/input-fields/).

## Hiding the Mini Filter

By default, the Mini Filter is shown whenever the Set Filter is used. If you would like to hide it, you can use the following:

```js
const gridOptions = {
    columnDefs: [
        {
            field: 'country',
            filter: 'agSetColumnFilter',
            filterParams: {
                suppressMiniFilter: true,
            },
        }
    ],

    // other grid options ...
}
```

The following example demonstrates hiding the mini filter. Note the following:

- The Athlete column's Set Filter shows the Mini Filter by default.
- The Country column's Set Filter does not have a Mini Filter as `filterParams.suppressMiniFilter = true`.

#### Hiding the Mini Filter

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ISetFilterParams,
  ModuleRegistry,
  NumberFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    // set filters
    { field: "athlete", filter: "agSetColumnFilter" },
    {
      field: "country",
      filter: "agSetColumnFilter",
      filterParams: {
        suppressMiniFilter: true,
      } as ISetFilterParams,
    },

    // number filters
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze", filter: "agNumberColumnFilter" },
  ],
  defaultColDef: {
    flex: 1,
    minWidth: 200,
    floatingFilter: true,
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Hiding the Mini Filter](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/mini-filter-hiding/typescript/)


---
product: "AG Grid"
title: "Set Filter - Mini Filter"
description: "This section describes the behaviour of the Mini Filter and shows how it can be configured."
enterprise: true
framework: angular
version: "36.2.0"
related:
    - title: "Filter List"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-filter-list/"
    - title: "Data Updates"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-data-updates/"
    - title: "Tree List"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-tree-list/"
    - title: "Excel Mode"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-excel-mode/"
    - title: "API"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-api/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Set Filter - Mini Filter

This section describes the behaviour of the Mini Filter and shows how it can be configured.

The Mini Filter allows the user to search for particular values in the Filter List. Entering text into the Mini Filter will narrow down the presented list of values shown inside the Set Filter, but by default will not filter the data inside the grid.

[Video](https://www.ag-grid.com/archive/36.2.0/_astro/mini-filter.-EPD4Dmp.mp4)

## Keyboard Shortcuts

When the `↵ Enter` key is pressed while on the Mini Filter, the Set Filter will exclusively select all values in the Filter List that pass the Mini Filter and apply the filter immediately (note that even if an Apply Button is used, hitting `↵ Enter` applies the filter).

Alternatively, you can choose to have the Mini Filter applied as the user is typing, i.e. as the Filter List is filtered, the Set Filter will be applied as described above so that the results in the grid will also be filtered at the same time. To enable this behaviour, use the following:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'country',
        filter: 'agSetColumnFilter',
        filterParams: {
            applyMiniFilterWhileTyping: true,
        },
    }
];
```

The following example demonstrates this behaviour. Note the following:

- The Athlete column's Set Filter shows the Mini Filter with default behaviour. Try typing in the Mini Filter to search the Filter List, and then hit the `↵ Enter` key and notice how the grid is filtered using the displayed values.
- The Country column's Set Filter applies the Mini Filter as you type because `filterParams.applyMiniFilterWhileTyping = true`.

#### Mini Filter Keyboard Shortcuts

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ISetFilterParams,
  ModuleRegistry,
  NumberFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    // set filters
    { field: "athlete", filter: "agSetColumnFilter" },
    {
      field: "country",
      filter: "agSetColumnFilter",
      filterParams: {
        applyMiniFilterWhileTyping: true,
      } as ISetFilterParams,
    },
    // number filters
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze", filter: "agNumberColumnFilter" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 200,
    floatingFilter: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Mini Filter Keyboard Shortcuts](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/mini-filter-keyboard-shortcuts/angular/)

## Custom Searches

Sometimes it is necessary to provide custom handling for Mini Filter searches, for example to substitute accented characters.

As with the [Text Filter](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-text/#text-formatter) it is possible to supply a Text Formatter to the Set Filter which formats the text before applying the Mini Filter compare logic. The snippet below shows how this can be configured:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'athlete',
        filter: 'agSetColumnFilter',
        filterParams: {
            textFormatter: value => {
                return value
                    .replace(/\s/g, '')
                    .replace(/[àáâãäå]/g, 'a')
                    .replace(/æ/g, 'ae')
                    .replace(/ç/g, 'c')
                    .replace(/[èéêë]/g, 'e')
                    .replace(/[ìíîï]/g, 'i')
                    .replace(/ñ/g, 'n')
                    .replace(/[òóôõö]/g, 'o')
                    .replace(/œ/g, 'oe')
                    .replace(/[ùúûü]/g, 'u')
                    .replace(/[ýÿ]/g, 'y')
                    .replace(/\W/g, '');
            }
        }
    }
];
```

The following example demonstrates searching when there are accented characters. Note the following:

- The Athlete column's Set filter is supplied a text formatter via `filterParams.textFormatter` to ignore accents.
- Searching using `'bjorn'` will return all values containing `'björn'`.

The formatter is also passed the grid `api` and `context` as a second argument, along with the `column` and `colDef` it is working on. One callback set on `defaultColDef.filterParams` can therefore serve every column it applies to.

#### Mini Filter Text Formatter

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ISetFilterParams,
  ModuleRegistry,
  NumberFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    // set filter
    {
      field: "athlete",
      filter: "agSetColumnFilter",
      filterParams: filterParams,
    },
    // number filters
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze", filter: "agNumberColumnFilter" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 200,
    floatingFilter: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}

function replaceAccents(value: string) {
  return value
    .replace(new RegExp("[àáâãäå]", "g"), "a")
    .replace(new RegExp("æ", "g"), "ae")
    .replace(new RegExp("ç", "g"), "c")
    .replace(new RegExp("[èéêë]", "g"), "e")
    .replace(new RegExp("[ìíîï]", "g"), "i")
    .replace(new RegExp("ñ", "g"), "n")
    .replace(new RegExp("[òóôõøö]", "g"), "o")
    .replace(new RegExp("œ", "g"), "oe")
    .replace(new RegExp("[ùúûü]", "g"), "u")
    .replace(new RegExp("[ýÿ]", "g"), "y")
    .replace(new RegExp("\\W", "g"), "");
}
const filterParams: ISetFilterParams = {
  textFormatter: replaceAccents,
};
```

[Live example: Mini Filter Text Formatter](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/mini-filter-text-formatter/angular/)

## Enabling Case-Sensitive Searches

By default the Mini Filter is case-insensitive. Practically this means that searching for `bl` would match Filter List values of `Black`, `blue` and `BLONDE`.

Case-sensitive searches can be enabled by using the `caseSensitive` filter parameter:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'colour',
        filter: 'agSetColumnFilter',
        filterParams: {
            caseSensitive: true
        }
    }
];
```

> **Note**
>
> The `caseSensitive` option also affects the values presented in the [Filter List](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-filter-list/#enabling-value-case-sensitivity) and [API](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-api/#enabling-case-sensitivity) behaviours.

See [Example: Filter List Case-Sensitivity](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/filter-set-filter-list/#enabling-value-case-sensitivity) for a demonstration of the change in behaviour.

## Text Customisation

Text used in the Mini Filter can be customised using [Localisation](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/localisation/).

The text shown as a placeholder in the Mini Filter textbox can be customised by setting `'searchOoo'`.

When no matching values are found when typing in the Mini Filter, a message is displayed. This can be customised by setting `'noMatches'`.

The example below shows this text being customised:

- `searchOoo` is set so that the Mini Filter textbox displays `'Search values...'` instead of the default text `'Search...'`
- `noMatches` is set so that when no matches are found for the Mini Filter search, the message displays `'No matches could be found.'` instead of `'No matches.'`

#### Text Customisation

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  LocaleModule,
  LocaleText,
  ModuleRegistry,
  NumberFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  LocaleModule,
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [localeText]="localeText"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    // set filters
    { field: "athlete", filter: "agSetColumnFilter" },
    { field: "country", filter: "agSetColumnFilter" },
    // number filters
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze", filter: "agNumberColumnFilter" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 200,
    floatingFilter: true,
  };
  localeText: LocaleText = {
    searchOoo: "Search values...",
    noMatches: "No matches could be found.",
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Text Customisation](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/text-customisation/angular/)

The Mini Filter input shares the grid-wide input behaviour (clear button, browser autocomplete) described in [Input Fields](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/input-fields/).

## Hiding the Mini Filter

By default, the Mini Filter is shown whenever the Set Filter is used. If you would like to hide it, you can use the following:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'country',
        filter: 'agSetColumnFilter',
        filterParams: {
            suppressMiniFilter: true,
        },
    }
];
```

The following example demonstrates hiding the mini filter. Note the following:

- The Athlete column's Set Filter shows the Mini Filter by default.
- The Country column's Set Filter does not have a Mini Filter as `filterParams.suppressMiniFilter = true`.

#### Hiding the Mini Filter

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ISetFilterParams,
  ModuleRegistry,
  NumberFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    // set filters
    { field: "athlete", filter: "agSetColumnFilter" },
    {
      field: "country",
      filter: "agSetColumnFilter",
      filterParams: {
        suppressMiniFilter: true,
      } as ISetFilterParams,
    },
    // number filters
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze", filter: "agNumberColumnFilter" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    minWidth: 200,
    floatingFilter: true,
  };
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Hiding the Mini Filter](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/mini-filter-hiding/angular/)


---
product: "AG Grid"
title: "Set Filter - Mini Filter"
description: "This section describes the behaviour of the Mini Filter and shows how it can be configured."
enterprise: true
framework: vue
version: "36.2.0"
related:
    - title: "Filter List"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-filter-list/"
    - title: "Data Updates"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-data-updates/"
    - title: "Tree List"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-tree-list/"
    - title: "Excel Mode"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-excel-mode/"
    - title: "API"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-api/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Set Filter - Mini Filter

This section describes the behaviour of the Mini Filter and shows how it can be configured.

The Mini Filter allows the user to search for particular values in the Filter List. Entering text into the Mini Filter will narrow down the presented list of values shown inside the Set Filter, but by default will not filter the data inside the grid.

[Video](https://www.ag-grid.com/archive/36.2.0/_astro/mini-filter.-EPD4Dmp.mp4)

## Keyboard Shortcuts

When the `↵ Enter` key is pressed while on the Mini Filter, the Set Filter will exclusively select all values in the Filter List that pass the Mini Filter and apply the filter immediately (note that even if an Apply Button is used, hitting `↵ Enter` applies the filter).

Alternatively, you can choose to have the Mini Filter applied as the user is typing, i.e. as the Filter List is filtered, the Set Filter will be applied as described above so that the results in the grid will also be filtered at the same time. To enable this behaviour, use the following:

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: 'country',
        filter: 'agSetColumnFilter',
        filterParams: {
            applyMiniFilterWhileTyping: true,
        },
    }
];
```

The following example demonstrates this behaviour. Note the following:

- The Athlete column's Set Filter shows the Mini Filter with default behaviour. Try typing in the Mini Filter to search the Filter List, and then hit the `↵ Enter` key and notice how the grid is filtered using the displayed values.
- The Country column's Set Filter applies the Mini Filter as you type because `filterParams.applyMiniFilterWhileTyping = true`.

#### Mini Filter Keyboard Shortcuts

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ISetFilterParams,
  ModuleRegistry,
  NumberFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      // set filters
      { field: "athlete", filter: "agSetColumnFilter" },
      {
        field: "country",
        filter: "agSetColumnFilter",
        filterParams: {
          applyMiniFilterWhileTyping: true,
        } as ISetFilterParams,
      },
      // number filters
      { field: "gold", filter: "agNumberColumnFilter" },
      { field: "silver", filter: "agNumberColumnFilter" },
      { field: "bronze", filter: "agNumberColumnFilter" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 200,
      floatingFilter: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Mini Filter Keyboard Shortcuts](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/mini-filter-keyboard-shortcuts/vue3/)

## Custom Searches

Sometimes it is necessary to provide custom handling for Mini Filter searches, for example to substitute accented characters.

As with the [Text Filter](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-text/#text-formatter) it is possible to supply a Text Formatter to the Set Filter which formats the text before applying the Mini Filter compare logic. The snippet below shows how this can be configured:

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: 'athlete',
        filter: 'agSetColumnFilter',
        filterParams: {
            textFormatter: value => {
                return value
                    .replace(/\s/g, '')
                    .replace(/[àáâãäå]/g, 'a')
                    .replace(/æ/g, 'ae')
                    .replace(/ç/g, 'c')
                    .replace(/[èéêë]/g, 'e')
                    .replace(/[ìíîï]/g, 'i')
                    .replace(/ñ/g, 'n')
                    .replace(/[òóôõö]/g, 'o')
                    .replace(/œ/g, 'oe')
                    .replace(/[ùúûü]/g, 'u')
                    .replace(/[ýÿ]/g, 'y')
                    .replace(/\W/g, '');
            }
        }
    }
];
```

The following example demonstrates searching when there are accented characters. Note the following:

- The Athlete column's Set filter is supplied a text formatter via `filterParams.textFormatter` to ignore accents.
- Searching using `'bjorn'` will return all values containing `'björn'`.

The formatter is also passed the grid `api` and `context` as a second argument, along with the `column` and `colDef` it is working on. One callback set on `defaultColDef.filterParams` can therefore serve every column it applies to.

#### Mini Filter Text Formatter

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ISetFilterParams,
  ModuleRegistry,
  NumberFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);

function replaceAccents(value: string) {
  return value
    .replace(new RegExp("[àáâãäå]", "g"), "a")
    .replace(new RegExp("æ", "g"), "ae")
    .replace(new RegExp("ç", "g"), "c")
    .replace(new RegExp("[èéêë]", "g"), "e")
    .replace(new RegExp("[ìíîï]", "g"), "i")
    .replace(new RegExp("ñ", "g"), "n")
    .replace(new RegExp("[òóôõøö]", "g"), "o")
    .replace(new RegExp("œ", "g"), "oe")
    .replace(new RegExp("[ùúûü]", "g"), "u")
    .replace(new RegExp("[ýÿ]", "g"), "y")
    .replace(new RegExp("\\W", "g"), "");
}

const filterParams: ISetFilterParams = {
  textFormatter: replaceAccents,
};

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      // set filter
      {
        field: "athlete",
        filter: "agSetColumnFilter",
        filterParams: filterParams,
      },
      // number filters
      { field: "gold", filter: "agNumberColumnFilter" },
      { field: "silver", filter: "agNumberColumnFilter" },
      { field: "bronze", filter: "agNumberColumnFilter" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 200,
      floatingFilter: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Mini Filter Text Formatter](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/mini-filter-text-formatter/vue3/)

## Enabling Case-Sensitive Searches

By default the Mini Filter is case-insensitive. Practically this means that searching for `bl` would match Filter List values of `Black`, `blue` and `BLONDE`.

Case-sensitive searches can be enabled by using the `caseSensitive` filter parameter:

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: 'colour',
        filter: 'agSetColumnFilter',
        filterParams: {
            caseSensitive: true
        }
    }
];
```

> **Note**
>
> The `caseSensitive` option also affects the values presented in the [Filter List](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-filter-list/#enabling-value-case-sensitivity) and [API](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-api/#enabling-case-sensitivity) behaviours.

See [Example: Filter List Case-Sensitivity](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/filter-set-filter-list/#enabling-value-case-sensitivity) for a demonstration of the change in behaviour.

## Text Customisation

Text used in the Mini Filter can be customised using [Localisation](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/localisation/).

The text shown as a placeholder in the Mini Filter textbox can be customised by setting `'searchOoo'`.

When no matching values are found when typing in the Mini Filter, a message is displayed. This can be customised by setting `'noMatches'`.

The example below shows this text being customised:

- `searchOoo` is set so that the Mini Filter textbox displays `'Search values...'` instead of the default text `'Search...'`
- `noMatches` is set so that when no matches are found for the Mini Filter search, the message displays `'No matches could be found.'` instead of `'No matches.'`

#### Text Customisation

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  LocaleModule,
  LocaleText,
  ModuleRegistry,
  NumberFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  LocaleModule,
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :localeText="localeText"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      // set filters
      { field: "athlete", filter: "agSetColumnFilter" },
      { field: "country", filter: "agSetColumnFilter" },
      // number filters
      { field: "gold", filter: "agNumberColumnFilter" },
      { field: "silver", filter: "agNumberColumnFilter" },
      { field: "bronze", filter: "agNumberColumnFilter" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 200,
      floatingFilter: true,
    });
    const localeText = ref<LocaleText>({
      searchOoo: "Search values...",
      noMatches: "No matches could be found.",
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      localeText,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Text Customisation](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/text-customisation/vue3/)

The Mini Filter input shares the grid-wide input behaviour (clear button, browser autocomplete) described in [Input Fields](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/input-fields/).

## Hiding the Mini Filter

By default, the Mini Filter is shown whenever the Set Filter is used. If you would like to hide it, you can use the following:

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: 'country',
        filter: 'agSetColumnFilter',
        filterParams: {
            suppressMiniFilter: true,
        },
    }
];
```

The following example demonstrates hiding the mini filter. Note the following:

- The Athlete column's Set Filter shows the Mini Filter by default.
- The Country column's Set Filter does not have a Mini Filter as `filterParams.suppressMiniFilter = true`.

#### Hiding the Mini Filter

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ISetFilterParams,
  ModuleRegistry,
  NumberFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
]);

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :rowData="rowData"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      // set filters
      { field: "athlete", filter: "agSetColumnFilter" },
      {
        field: "country",
        filter: "agSetColumnFilter",
        filterParams: {
          suppressMiniFilter: true,
        } as ISetFilterParams,
      },
      // number filters
      { field: "gold", filter: "agNumberColumnFilter" },
      { field: "silver", filter: "agNumberColumnFilter" },
      { field: "bronze", filter: "agNumberColumnFilter" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      minWidth: 200,
      floatingFilter: true,
    });
    const rowData = ref<IOlympicData[]>(null);

    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Hiding the Mini Filter](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/mini-filter-hiding/vue3/)


---
product: "AG Grid"
title: "Set Filter - Mini Filter"
description: "This section describes the behaviour of the Mini Filter and shows how it can be configured."
enterprise: true
framework: react
version: "36.2.0"
related:
    - title: "Filter List"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-filter-list/"
    - title: "Data Updates"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-data-updates/"
    - title: "Tree List"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-tree-list/"
    - title: "Excel Mode"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-excel-mode/"
    - title: "API"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-api/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Set Filter - Mini Filter

This section describes the behaviour of the Mini Filter and shows how it can be configured.

The Mini Filter allows the user to search for particular values in the Filter List. Entering text into the Mini Filter will narrow down the presented list of values shown inside the Set Filter, but by default will not filter the data inside the grid.

[Video](https://www.ag-grid.com/archive/36.2.0/_astro/mini-filter.-EPD4Dmp.mp4)

## Keyboard Shortcuts

When the `↵ Enter` key is pressed while on the Mini Filter, the Set Filter will exclusively select all values in the Filter List that pass the Mini Filter and apply the filter immediately (note that even if an Apply Button is used, hitting `↵ Enter` applies the filter).

Alternatively, you can choose to have the Mini Filter applied as the user is typing, i.e. as the Filter List is filtered, the Set Filter will be applied as described above so that the results in the grid will also be filtered at the same time. To enable this behaviour, use the following:

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'country',
        filter: 'agSetColumnFilter',
        filterParams: {
            applyMiniFilterWhileTyping: true,
        },
    }
]);

<AgGridReact columnDefs={columnDefs} />
```

The following example demonstrates this behaviour. Note the following:

- The Athlete column's Set Filter shows the Mini Filter with default behaviour. Try typing in the Mini Filter to search the Filter List, and then hit the `↵ Enter` key and notice how the grid is filtered using the displayed values.
- The Country column's Set Filter applies the Mini Filter as you type because `filterParams.applyMiniFilterWhileTyping = true`.

#### Mini Filter Keyboard Shortcuts

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ISetFilterParams,
  ModuleRegistry,
  NumberFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    // set filters
    { field: "athlete", filter: "agSetColumnFilter" },
    {
      field: "country",
      filter: "agSetColumnFilter",
      filterParams: {
        applyMiniFilterWhileTyping: true,
      } as ISetFilterParams,
    },
    // number filters
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze", filter: "agNumberColumnFilter" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 200,
      floatingFilter: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Mini Filter Keyboard Shortcuts](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/mini-filter-keyboard-shortcuts/reactFunctionalTs/)

## Custom Searches

Sometimes it is necessary to provide custom handling for Mini Filter searches, for example to substitute accented characters.

As with the [Text Filter](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-text/#text-formatter) it is possible to supply a Text Formatter to the Set Filter which formats the text before applying the Mini Filter compare logic. The snippet below shows how this can be configured:

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'athlete',
        filter: 'agSetColumnFilter',
        filterParams: {
            textFormatter: value => {
                return value
                    .replace(/\s/g, '')
                    .replace(/[àáâãäå]/g, 'a')
                    .replace(/æ/g, 'ae')
                    .replace(/ç/g, 'c')
                    .replace(/[èéêë]/g, 'e')
                    .replace(/[ìíîï]/g, 'i')
                    .replace(/ñ/g, 'n')
                    .replace(/[òóôõö]/g, 'o')
                    .replace(/œ/g, 'oe')
                    .replace(/[ùúûü]/g, 'u')
                    .replace(/[ýÿ]/g, 'y')
                    .replace(/\W/g, '');
            }
        }
    }
]);

<AgGridReact columnDefs={columnDefs} />
```

The following example demonstrates searching when there are accented characters. Note the following:

- The Athlete column's Set filter is supplied a text formatter via `filterParams.textFormatter` to ignore accents.
- Searching using `'bjorn'` will return all values containing `'björn'`.

The formatter is also passed the grid `api` and `context` as a second argument, along with the `column` and `colDef` it is working on. One callback set on `defaultColDef.filterParams` can therefore serve every column it applies to.

#### Mini Filter Text Formatter

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ISetFilterParams,
  ModuleRegistry,
  NumberFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
];

function replaceAccents(value: string) {
  return value
    .replace(new RegExp("[àáâãäå]", "g"), "a")
    .replace(new RegExp("æ", "g"), "ae")
    .replace(new RegExp("ç", "g"), "c")
    .replace(new RegExp("[èéêë]", "g"), "e")
    .replace(new RegExp("[ìíîï]", "g"), "i")
    .replace(new RegExp("ñ", "g"), "n")
    .replace(new RegExp("[òóôõøö]", "g"), "o")
    .replace(new RegExp("œ", "g"), "oe")
    .replace(new RegExp("[ùúûü]", "g"), "u")
    .replace(new RegExp("[ýÿ]", "g"), "y")
    .replace(new RegExp("\\W", "g"), "");
}

const filterParams: ISetFilterParams = {
  textFormatter: replaceAccents,
};

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    // set filter
    {
      field: "athlete",
      filter: "agSetColumnFilter",
      filterParams: filterParams,
    },
    // number filters
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze", filter: "agNumberColumnFilter" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 200,
      floatingFilter: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Mini Filter Text Formatter](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/mini-filter-text-formatter/reactFunctionalTs/)

## Enabling Case-Sensitive Searches

By default the Mini Filter is case-insensitive. Practically this means that searching for `bl` would match Filter List values of `Black`, `blue` and `BLONDE`.

Case-sensitive searches can be enabled by using the `caseSensitive` filter parameter:

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'colour',
        filter: 'agSetColumnFilter',
        filterParams: {
            caseSensitive: true
        }
    }
]);

<AgGridReact columnDefs={columnDefs} />
```

> **Note**
>
> The `caseSensitive` option also affects the values presented in the [Filter List](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-filter-list/#enabling-value-case-sensitivity) and [API](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-api/#enabling-case-sensitivity) behaviours.

See [Example: Filter List Case-Sensitivity](https://www.ag-grid.com/archive/36.2.0/react-data-grid/filter-set-filter-list/#enabling-value-case-sensitivity) for a demonstration of the change in behaviour.

## Text Customisation

Text used in the Mini Filter can be customised using [Localisation](https://www.ag-grid.com/archive/36.2.0/react-data-grid/localisation/).

The text shown as a placeholder in the Mini Filter textbox can be customised by setting `'searchOoo'`.

When no matching values are found when typing in the Mini Filter, a message is displayed. This can be customised by setting `'noMatches'`.

The example below shows this text being customised:

- `searchOoo` is set so that the Mini Filter textbox displays `'Search values...'` instead of the default text `'Search...'`
- `noMatches` is set so that when no matches are found for the Mini Filter search, the message displays `'No matches could be found.'` instead of `'No matches.'`

#### Text Customisation

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  LocaleModule,
  LocaleText,
  ModuleRegistry,
  NumberFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  LocaleModule,
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    // set filters
    { field: "athlete", filter: "agSetColumnFilter" },
    { field: "country", filter: "agSetColumnFilter" },
    // number filters
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze", filter: "agNumberColumnFilter" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 200,
      floatingFilter: true,
    };
  }, []);
  const localeText = useMemo<LocaleText>(() => {
    return {
      searchOoo: "Search values...",
      noMatches: "No matches could be found.",
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            localeText={localeText}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Text Customisation](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/text-customisation/reactFunctionalTs/)

The Mini Filter input shares the grid-wide input behaviour (clear button, browser autocomplete) described in [Input Fields](https://www.ag-grid.com/archive/36.2.0/react-data-grid/input-fields/).

## Hiding the Mini Filter

By default, the Mini Filter is shown whenever the Set Filter is used. If you would like to hide it, you can use the following:

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'country',
        filter: 'agSetColumnFilter',
        filterParams: {
            suppressMiniFilter: true,
        },
    }
]);

<AgGridReact columnDefs={columnDefs} />
```

The following example demonstrates hiding the mini filter. Note the following:

- The Athlete column's Set Filter shows the Mini Filter by default.
- The Country column's Set Filter does not have a Mini Filter as `filterParams.suppressMiniFilter = true`.

#### Hiding the Mini Filter

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ISetFilterParams,
  ModuleRegistry,
  NumberFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnMenuModule,
  ContextMenuModule,
  SetFilterModule,
  NumberFilterModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    // set filters
    { field: "athlete", filter: "agSetColumnFilter" },
    {
      field: "country",
      filter: "agSetColumnFilter",
      filterParams: {
        suppressMiniFilter: true,
      } as ISetFilterParams,
    },
    // number filters
    { field: "gold", filter: "agNumberColumnFilter" },
    { field: "silver", filter: "agNumberColumnFilter" },
    { field: "bronze", filter: "agNumberColumnFilter" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      minWidth: 200,
      floatingFilter: true,
    };
  }, []);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact<IOlympicData>
            rowData={data}
            loading={loading}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Hiding the Mini Filter](https://www.ag-grid.com/archive/36.2.0/examples/filter-set-mini-filter/mini-filter-hiding/reactFunctionalTs/)
